// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ptz_action_server_msgs:action/PtzFrame.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__TRAITS_HPP_
#define PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ptz_action_server_msgs/action/detail/ptz_frame__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: frame_id
  {
    out << "frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.frame_id, out);
    out << ", ";
  }

  // member: zoom
  {
    out << "zoom: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.frame_id, out);
    out << "\n";
  }

  // member: zoom
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zoom: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_Goal & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_Goal>()
{
  return "ptz_action_server_msgs::action::PtzFrame_Goal";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_Goal>()
{
  return "ptz_action_server_msgs/action/PtzFrame_Goal";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_Result & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_Result>()
{
  return "ptz_action_server_msgs::action::PtzFrame_Result";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_Result>()
{
  return "ptz_action_server_msgs/action/PtzFrame_Result";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: pan_remaining
  {
    out << "pan_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.pan_remaining, out);
    out << ", ";
  }

  // member: tilt_remaining
  {
    out << "tilt_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.tilt_remaining, out);
    out << ", ";
  }

  // member: zoom_remaining
  {
    out << "zoom_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom_remaining, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pan_remaining
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pan_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.pan_remaining, out);
    out << "\n";
  }

  // member: tilt_remaining
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tilt_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.tilt_remaining, out);
    out << "\n";
  }

  // member: zoom_remaining
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zoom_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom_remaining, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_Feedback & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_Feedback>()
{
  return "ptz_action_server_msgs::action::PtzFrame_Feedback";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_Feedback>()
{
  return "ptz_action_server_msgs/action/PtzFrame_Feedback";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "ptz_action_server_msgs/action/detail/ptz_frame__traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_SendGoal_Request & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>()
{
  return "ptz_action_server_msgs::action::PtzFrame_SendGoal_Request";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>()
{
  return "ptz_action_server_msgs/action/PtzFrame_SendGoal_Request";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_SendGoal_Response & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>()
{
  return "ptz_action_server_msgs::action::PtzFrame_SendGoal_Response";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>()
{
  return "ptz_action_server_msgs/action/PtzFrame_SendGoal_Response";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_SendGoal>()
{
  return "ptz_action_server_msgs::action::PtzFrame_SendGoal";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_SendGoal>()
{
  return "ptz_action_server_msgs/action/PtzFrame_SendGoal";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>::value &&
    has_fixed_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>::value &&
    has_bounded_size<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<ptz_action_server_msgs::action::PtzFrame_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_GetResult_Request & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>()
{
  return "ptz_action_server_msgs::action::PtzFrame_GetResult_Request";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>()
{
  return "ptz_action_server_msgs/action/PtzFrame_GetResult_Request";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_frame__traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_GetResult_Response & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>()
{
  return "ptz_action_server_msgs::action::PtzFrame_GetResult_Response";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>()
{
  return "ptz_action_server_msgs/action/PtzFrame_GetResult_Response";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Result>::value> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Result>::value> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_GetResult>()
{
  return "ptz_action_server_msgs::action::PtzFrame_GetResult";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_GetResult>()
{
  return "ptz_action_server_msgs/action/PtzFrame_GetResult";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>::value &&
    has_fixed_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>::value &&
    has_bounded_size<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>::value
  >
{
};

template<>
struct is_service<ptz_action_server_msgs::action::PtzFrame_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<ptz_action_server_msgs::action::PtzFrame_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ptz_action_server_msgs::action::PtzFrame_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_frame__traits.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const PtzFrame_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzFrame_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzFrame_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::action::PtzFrame_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::action::PtzFrame_FeedbackMessage & msg)
{
  return ptz_action_server_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage>()
{
  return "ptz_action_server_msgs::action::PtzFrame_FeedbackMessage";
}

template<>
inline const char * name<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage>()
{
  return "ptz_action_server_msgs/action/PtzFrame_FeedbackMessage";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<ptz_action_server_msgs::action::PtzFrame_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<ptz_action_server_msgs::action::PtzFrame_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<ptz_action_server_msgs::action::PtzFrame>
  : std::true_type
{
};

template<>
struct is_action_goal<ptz_action_server_msgs::action::PtzFrame_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<ptz_action_server_msgs::action::PtzFrame_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<ptz_action_server_msgs::action::PtzFrame_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__TRAITS_HPP_
