// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ptz_action_server_msgs:action/PtzRelTo.idl
// generated code does not contain a copyright notice
#include "ptz_action_server_msgs/action/detail/ptz_rel_to__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ptz`
#include "ptz_action_server_msgs/msg/detail/ptz__functions.h"
// Member `frame_id`
#include "rosidl_runtime_c/string_functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_Goal__init(ptz_action_server_msgs__action__PtzRelTo_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // ptz
  if (!ptz_action_server_msgs__msg__Ptz__init(&msg->ptz)) {
    ptz_action_server_msgs__action__PtzRelTo_Goal__fini(msg);
    return false;
  }
  // frame_id
  if (!rosidl_runtime_c__String__init(&msg->frame_id)) {
    ptz_action_server_msgs__action__PtzRelTo_Goal__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Goal__fini(ptz_action_server_msgs__action__PtzRelTo_Goal * msg)
{
  if (!msg) {
    return;
  }
  // ptz
  ptz_action_server_msgs__msg__Ptz__fini(&msg->ptz);
  // frame_id
  rosidl_runtime_c__String__fini(&msg->frame_id);
}

bool
ptz_action_server_msgs__action__PtzRelTo_Goal__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Goal * lhs, const ptz_action_server_msgs__action__PtzRelTo_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ptz
  if (!ptz_action_server_msgs__msg__Ptz__are_equal(
      &(lhs->ptz), &(rhs->ptz)))
  {
    return false;
  }
  // frame_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->frame_id), &(rhs->frame_id)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Goal__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Goal * input,
  ptz_action_server_msgs__action__PtzRelTo_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // ptz
  if (!ptz_action_server_msgs__msg__Ptz__copy(
      &(input->ptz), &(output->ptz)))
  {
    return false;
  }
  // frame_id
  if (!rosidl_runtime_c__String__copy(
      &(input->frame_id), &(output->frame_id)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_Goal *
ptz_action_server_msgs__action__PtzRelTo_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Goal * msg = (ptz_action_server_msgs__action__PtzRelTo_Goal *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_Goal));
  bool success = ptz_action_server_msgs__action__PtzRelTo_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_Goal__destroy(ptz_action_server_msgs__action__PtzRelTo_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Goal * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_Goal *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence *
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_Goal * data =
      (ptz_action_server_msgs__action__PtzRelTo_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `message`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_Result__init(ptz_action_server_msgs__action__PtzRelTo_Result * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    ptz_action_server_msgs__action__PtzRelTo_Result__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Result__fini(ptz_action_server_msgs__action__PtzRelTo_Result * msg)
{
  if (!msg) {
    return;
  }
  // success
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

bool
ptz_action_server_msgs__action__PtzRelTo_Result__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Result * lhs, const ptz_action_server_msgs__action__PtzRelTo_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Result__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Result * input,
  ptz_action_server_msgs__action__PtzRelTo_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_Result *
ptz_action_server_msgs__action__PtzRelTo_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Result * msg = (ptz_action_server_msgs__action__PtzRelTo_Result *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_Result));
  bool success = ptz_action_server_msgs__action__PtzRelTo_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_Result__destroy(ptz_action_server_msgs__action__PtzRelTo_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Result * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_Result *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_Result__Sequence *
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_Result__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Result__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_Result * data =
      (ptz_action_server_msgs__action__PtzRelTo_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__init(ptz_action_server_msgs__action__PtzRelTo_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // pan_remaining
  // tilt_remaining
  // zoom_remaining
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(ptz_action_server_msgs__action__PtzRelTo_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // pan_remaining
  // tilt_remaining
  // zoom_remaining
}

bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Feedback * lhs, const ptz_action_server_msgs__action__PtzRelTo_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // pan_remaining
  if (lhs->pan_remaining != rhs->pan_remaining) {
    return false;
  }
  // tilt_remaining
  if (lhs->tilt_remaining != rhs->tilt_remaining) {
    return false;
  }
  // zoom_remaining
  if (lhs->zoom_remaining != rhs->zoom_remaining) {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Feedback * input,
  ptz_action_server_msgs__action__PtzRelTo_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // pan_remaining
  output->pan_remaining = input->pan_remaining;
  // tilt_remaining
  output->tilt_remaining = input->tilt_remaining;
  // zoom_remaining
  output->zoom_remaining = input->zoom_remaining;
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_Feedback *
ptz_action_server_msgs__action__PtzRelTo_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Feedback * msg = (ptz_action_server_msgs__action__PtzRelTo_Feedback *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_Feedback));
  bool success = ptz_action_server_msgs__action__PtzRelTo_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_Feedback__destroy(ptz_action_server_msgs__action__PtzRelTo_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Feedback * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_Feedback *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence *
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_Feedback * data =
      (ptz_action_server_msgs__action__PtzRelTo_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_rel_to__functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__init(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!ptz_action_server_msgs__action__PtzRelTo_Goal__init(&msg->goal)) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  ptz_action_server_msgs__action__PtzRelTo_Goal__fini(&msg->goal);
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__are_equal(const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * lhs, const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!ptz_action_server_msgs__action__PtzRelTo_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__copy(
  const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * input,
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!ptz_action_server_msgs__action__PtzRelTo_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request *
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * msg = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request));
  bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__destroy(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence *
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request * data =
      (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__init(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__are_equal(const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * lhs, const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__copy(
  const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * input,
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response *
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * msg = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response));
  bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__destroy(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence *
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response * data =
      (ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__init(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__are_equal(const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * lhs, const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__copy(
  const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * input,
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_GetResult_Request *
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * msg = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Request *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request));
  bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__destroy(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Request *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence *
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Request * data =
      (ptz_action_server_msgs__action__PtzRelTo_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_rel_to__functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__init(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!ptz_action_server_msgs__action__PtzRelTo_Result__init(&msg->result)) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  ptz_action_server_msgs__action__PtzRelTo_Result__fini(&msg->result);
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__are_equal(const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * lhs, const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!ptz_action_server_msgs__action__PtzRelTo_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__copy(
  const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * input,
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!ptz_action_server_msgs__action__PtzRelTo_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_GetResult_Response *
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * msg = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Response *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response));
  bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__destroy(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Response *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence *
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_GetResult_Response * data =
      (ptz_action_server_msgs__action__PtzRelTo_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_rel_to__functions.h"

bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__init(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__init(&msg->feedback)) {
    ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  ptz_action_server_msgs__action__PtzRelTo_Feedback__fini(&msg->feedback);
}

bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__are_equal(const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * lhs, const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__copy(
  const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * input,
  ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!ptz_action_server_msgs__action__PtzRelTo_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage *
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * msg = (ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage));
  bool success = ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__destroy(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__init(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__fini(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence *
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * array = (ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__destroy(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__are_equal(const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * lhs, const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence__copy(
  const ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * input,
  ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage * data =
      (ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__action__PtzRelTo_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
