// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ptz_action_server_msgs:msg/Ptz.idl
// generated code does not contain a copyright notice
#include "ptz_action_server_msgs/msg/detail/ptz__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
ptz_action_server_msgs__msg__Ptz__init(ptz_action_server_msgs__msg__Ptz * msg)
{
  if (!msg) {
    return false;
  }
  // pan
  // tilt
  // zoom
  return true;
}

void
ptz_action_server_msgs__msg__Ptz__fini(ptz_action_server_msgs__msg__Ptz * msg)
{
  if (!msg) {
    return;
  }
  // pan
  // tilt
  // zoom
}

bool
ptz_action_server_msgs__msg__Ptz__are_equal(const ptz_action_server_msgs__msg__Ptz * lhs, const ptz_action_server_msgs__msg__Ptz * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // pan
  if (lhs->pan != rhs->pan) {
    return false;
  }
  // tilt
  if (lhs->tilt != rhs->tilt) {
    return false;
  }
  // zoom
  if (lhs->zoom != rhs->zoom) {
    return false;
  }
  return true;
}

bool
ptz_action_server_msgs__msg__Ptz__copy(
  const ptz_action_server_msgs__msg__Ptz * input,
  ptz_action_server_msgs__msg__Ptz * output)
{
  if (!input || !output) {
    return false;
  }
  // pan
  output->pan = input->pan;
  // tilt
  output->tilt = input->tilt;
  // zoom
  output->zoom = input->zoom;
  return true;
}

ptz_action_server_msgs__msg__Ptz *
ptz_action_server_msgs__msg__Ptz__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__msg__Ptz * msg = (ptz_action_server_msgs__msg__Ptz *)allocator.allocate(sizeof(ptz_action_server_msgs__msg__Ptz), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ptz_action_server_msgs__msg__Ptz));
  bool success = ptz_action_server_msgs__msg__Ptz__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ptz_action_server_msgs__msg__Ptz__destroy(ptz_action_server_msgs__msg__Ptz * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ptz_action_server_msgs__msg__Ptz__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ptz_action_server_msgs__msg__Ptz__Sequence__init(ptz_action_server_msgs__msg__Ptz__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__msg__Ptz * data = NULL;

  if (size) {
    data = (ptz_action_server_msgs__msg__Ptz *)allocator.zero_allocate(size, sizeof(ptz_action_server_msgs__msg__Ptz), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ptz_action_server_msgs__msg__Ptz__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ptz_action_server_msgs__msg__Ptz__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ptz_action_server_msgs__msg__Ptz__Sequence__fini(ptz_action_server_msgs__msg__Ptz__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ptz_action_server_msgs__msg__Ptz__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ptz_action_server_msgs__msg__Ptz__Sequence *
ptz_action_server_msgs__msg__Ptz__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ptz_action_server_msgs__msg__Ptz__Sequence * array = (ptz_action_server_msgs__msg__Ptz__Sequence *)allocator.allocate(sizeof(ptz_action_server_msgs__msg__Ptz__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ptz_action_server_msgs__msg__Ptz__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ptz_action_server_msgs__msg__Ptz__Sequence__destroy(ptz_action_server_msgs__msg__Ptz__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ptz_action_server_msgs__msg__Ptz__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ptz_action_server_msgs__msg__Ptz__Sequence__are_equal(const ptz_action_server_msgs__msg__Ptz__Sequence * lhs, const ptz_action_server_msgs__msg__Ptz__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ptz_action_server_msgs__msg__Ptz__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ptz_action_server_msgs__msg__Ptz__Sequence__copy(
  const ptz_action_server_msgs__msg__Ptz__Sequence * input,
  ptz_action_server_msgs__msg__Ptz__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ptz_action_server_msgs__msg__Ptz);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ptz_action_server_msgs__msg__Ptz * data =
      (ptz_action_server_msgs__msg__Ptz *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ptz_action_server_msgs__msg__Ptz__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ptz_action_server_msgs__msg__Ptz__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ptz_action_server_msgs__msg__Ptz__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
