// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from ptz_action_server_msgs:msg/Ptz.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__FUNCTIONS_H_
#define PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "ptz_action_server_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "ptz_action_server_msgs/msg/detail/ptz__struct.h"

/// Initialize msg/Ptz message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * ptz_action_server_msgs__msg__Ptz
 * )) before or use
 * ptz_action_server_msgs__msg__Ptz__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__init(ptz_action_server_msgs__msg__Ptz * msg);

/// Finalize msg/Ptz message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
void
ptz_action_server_msgs__msg__Ptz__fini(ptz_action_server_msgs__msg__Ptz * msg);

/// Create msg/Ptz message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * ptz_action_server_msgs__msg__Ptz__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
ptz_action_server_msgs__msg__Ptz *
ptz_action_server_msgs__msg__Ptz__create();

/// Destroy msg/Ptz message.
/**
 * It calls
 * ptz_action_server_msgs__msg__Ptz__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
void
ptz_action_server_msgs__msg__Ptz__destroy(ptz_action_server_msgs__msg__Ptz * msg);

/// Check for msg/Ptz message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__are_equal(const ptz_action_server_msgs__msg__Ptz * lhs, const ptz_action_server_msgs__msg__Ptz * rhs);

/// Copy a msg/Ptz message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__copy(
  const ptz_action_server_msgs__msg__Ptz * input,
  ptz_action_server_msgs__msg__Ptz * output);

/// Initialize array of msg/Ptz messages.
/**
 * It allocates the memory for the number of elements and calls
 * ptz_action_server_msgs__msg__Ptz__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__Sequence__init(ptz_action_server_msgs__msg__Ptz__Sequence * array, size_t size);

/// Finalize array of msg/Ptz messages.
/**
 * It calls
 * ptz_action_server_msgs__msg__Ptz__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
void
ptz_action_server_msgs__msg__Ptz__Sequence__fini(ptz_action_server_msgs__msg__Ptz__Sequence * array);

/// Create array of msg/Ptz messages.
/**
 * It allocates the memory for the array and calls
 * ptz_action_server_msgs__msg__Ptz__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
ptz_action_server_msgs__msg__Ptz__Sequence *
ptz_action_server_msgs__msg__Ptz__Sequence__create(size_t size);

/// Destroy array of msg/Ptz messages.
/**
 * It calls
 * ptz_action_server_msgs__msg__Ptz__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
void
ptz_action_server_msgs__msg__Ptz__Sequence__destroy(ptz_action_server_msgs__msg__Ptz__Sequence * array);

/// Check for msg/Ptz message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__Sequence__are_equal(const ptz_action_server_msgs__msg__Ptz__Sequence * lhs, const ptz_action_server_msgs__msg__Ptz__Sequence * rhs);

/// Copy an array of msg/Ptz messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_ptz_action_server_msgs
bool
ptz_action_server_msgs__msg__Ptz__Sequence__copy(
  const ptz_action_server_msgs__msg__Ptz__Sequence * input,
  ptz_action_server_msgs__msg__Ptz__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__FUNCTIONS_H_
