// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ptz_action_server_msgs:msg/Ptz.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__STRUCT_HPP_
#define PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__msg__Ptz __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__msg__Ptz __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Ptz_
{
  using Type = Ptz_<ContainerAllocator>;

  explicit Ptz_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pan = 0.0f;
      this->tilt = 0.0f;
      this->zoom = 0.0f;
    }
  }

  explicit Ptz_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pan = 0.0f;
      this->tilt = 0.0f;
      this->zoom = 0.0f;
    }
  }

  // field types and members
  using _pan_type =
    float;
  _pan_type pan;
  using _tilt_type =
    float;
  _tilt_type tilt;
  using _zoom_type =
    float;
  _zoom_type zoom;

  // setters for named parameter idiom
  Type & set__pan(
    const float & _arg)
  {
    this->pan = _arg;
    return *this;
  }
  Type & set__tilt(
    const float & _arg)
  {
    this->tilt = _arg;
    return *this;
  }
  Type & set__zoom(
    const float & _arg)
  {
    this->zoom = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__msg__Ptz
    std::shared_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__msg__Ptz
    std::shared_ptr<ptz_action_server_msgs::msg::Ptz_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Ptz_ & other) const
  {
    if (this->pan != other.pan) {
      return false;
    }
    if (this->tilt != other.tilt) {
      return false;
    }
    if (this->zoom != other.zoom) {
      return false;
    }
    return true;
  }
  bool operator!=(const Ptz_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Ptz_

// alias to use template instance with default allocator
using Ptz =
  ptz_action_server_msgs::msg::Ptz_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ptz_action_server_msgs

#endif  // PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ__STRUCT_HPP_
