// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ptz_action_server_msgs:msg/PtzState.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__STRUCT_H_
#define PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MODE_IDLE'.
enum
{
  ptz_action_server_msgs__msg__PtzState__MODE_IDLE = 0
};

/// Constant 'MODE_POSITION'.
/**
  * The device is moving under position control
 */
enum
{
  ptz_action_server_msgs__msg__PtzState__MODE_POSITION = 1
};

/// Constant 'MODE_VELOCITY'.
/**
  * The device is moving under velocity control
 */
enum
{
  ptz_action_server_msgs__msg__PtzState__MODE_VELOCITY = 2
};

/// Struct defined in msg/PtzState in the package ptz_action_server_msgs.
/**
  * The device is not currently moving
 */
typedef struct ptz_action_server_msgs__msg__PtzState
{
  /// The device's current operating mode
  int8_t mode;
  /// The current position or velocity of a PTZ camera or PTU
  float pan;
  float tilt;
  float zoom;
} ptz_action_server_msgs__msg__PtzState;

// Struct for a sequence of ptz_action_server_msgs__msg__PtzState.
typedef struct ptz_action_server_msgs__msg__PtzState__Sequence
{
  ptz_action_server_msgs__msg__PtzState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__msg__PtzState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__STRUCT_H_
