// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ptz_action_server_msgs:action/PtzFrame.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__STRUCT_HPP_
#define PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Goal __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Goal __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_Goal_
{
  using Type = PtzFrame_Goal_<ContainerAllocator>;

  explicit PtzFrame_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->frame_id = "";
      this->zoom = 0.0f;
    }
  }

  explicit PtzFrame_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : frame_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->frame_id = "";
      this->zoom = 0.0f;
    }
  }

  // field types and members
  using _frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _frame_id_type frame_id;
  using _zoom_type =
    float;
  _zoom_type zoom;

  // setters for named parameter idiom
  Type & set__frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->frame_id = _arg;
    return *this;
  }
  Type & set__zoom(
    const float & _arg)
  {
    this->zoom = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Goal
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Goal
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_Goal_ & other) const
  {
    if (this->frame_id != other.frame_id) {
      return false;
    }
    if (this->zoom != other.zoom) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_Goal_

// alias to use template instance with default allocator
using PtzFrame_Goal =
  ptz_action_server_msgs::action::PtzFrame_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs


#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Result __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Result __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_Result_
{
  using Type = PtzFrame_Result_<ContainerAllocator>;

  explicit PtzFrame_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit PtzFrame_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Result
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Result
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_Result_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_Result_

// alias to use template instance with default allocator
using PtzFrame_Result =
  ptz_action_server_msgs::action::PtzFrame_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs


#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Feedback __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_Feedback_
{
  using Type = PtzFrame_Feedback_<ContainerAllocator>;

  explicit PtzFrame_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pan_remaining = 0.0f;
      this->tilt_remaining = 0.0f;
      this->zoom_remaining = 0.0f;
    }
  }

  explicit PtzFrame_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pan_remaining = 0.0f;
      this->tilt_remaining = 0.0f;
      this->zoom_remaining = 0.0f;
    }
  }

  // field types and members
  using _pan_remaining_type =
    float;
  _pan_remaining_type pan_remaining;
  using _tilt_remaining_type =
    float;
  _tilt_remaining_type tilt_remaining;
  using _zoom_remaining_type =
    float;
  _zoom_remaining_type zoom_remaining;

  // setters for named parameter idiom
  Type & set__pan_remaining(
    const float & _arg)
  {
    this->pan_remaining = _arg;
    return *this;
  }
  Type & set__tilt_remaining(
    const float & _arg)
  {
    this->tilt_remaining = _arg;
    return *this;
  }
  Type & set__zoom_remaining(
    const float & _arg)
  {
    this->zoom_remaining = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Feedback
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_Feedback
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_Feedback_ & other) const
  {
    if (this->pan_remaining != other.pan_remaining) {
      return false;
    }
    if (this->tilt_remaining != other.tilt_remaining) {
      return false;
    }
    if (this->zoom_remaining != other.zoom_remaining) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_Feedback_

// alias to use template instance with default allocator
using PtzFrame_Feedback =
  ptz_action_server_msgs::action::PtzFrame_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "ptz_action_server_msgs/action/detail/ptz_frame__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Request __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_SendGoal_Request_
{
  using Type = PtzFrame_SendGoal_Request_<ContainerAllocator>;

  explicit PtzFrame_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit PtzFrame_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const ptz_action_server_msgs::action::PtzFrame_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Request
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Request
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_SendGoal_Request_

// alias to use template instance with default allocator
using PtzFrame_SendGoal_Request =
  ptz_action_server_msgs::action::PtzFrame_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Response __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_SendGoal_Response_
{
  using Type = PtzFrame_SendGoal_Response_<ContainerAllocator>;

  explicit PtzFrame_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit PtzFrame_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Response
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_SendGoal_Response
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_SendGoal_Response_

// alias to use template instance with default allocator
using PtzFrame_SendGoal_Response =
  ptz_action_server_msgs::action::PtzFrame_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace ptz_action_server_msgs
{

namespace action
{

struct PtzFrame_SendGoal
{
  using Request = ptz_action_server_msgs::action::PtzFrame_SendGoal_Request;
  using Response = ptz_action_server_msgs::action::PtzFrame_SendGoal_Response;
};

}  // namespace action

}  // namespace ptz_action_server_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Request __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_GetResult_Request_
{
  using Type = PtzFrame_GetResult_Request_<ContainerAllocator>;

  explicit PtzFrame_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit PtzFrame_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Request
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Request
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_GetResult_Request_

// alias to use template instance with default allocator
using PtzFrame_GetResult_Request =
  ptz_action_server_msgs::action::PtzFrame_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs


// Include directives for member types
// Member 'result'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_frame__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Response __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_GetResult_Response_
{
  using Type = PtzFrame_GetResult_Response_<ContainerAllocator>;

  explicit PtzFrame_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit PtzFrame_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const ptz_action_server_msgs::action::PtzFrame_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Response
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_GetResult_Response
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_GetResult_Response_

// alias to use template instance with default allocator
using PtzFrame_GetResult_Response =
  ptz_action_server_msgs::action::PtzFrame_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs

namespace ptz_action_server_msgs
{

namespace action
{

struct PtzFrame_GetResult
{
  using Request = ptz_action_server_msgs::action::PtzFrame_GetResult_Request;
  using Response = ptz_action_server_msgs::action::PtzFrame_GetResult_Response;
};

}  // namespace action

}  // namespace ptz_action_server_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_frame__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__ptz_action_server_msgs__action__PtzFrame_FeedbackMessage __declspec(deprecated)
#endif

namespace ptz_action_server_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct PtzFrame_FeedbackMessage_
{
  using Type = PtzFrame_FeedbackMessage_<ContainerAllocator>;

  explicit PtzFrame_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit PtzFrame_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const ptz_action_server_msgs::action::PtzFrame_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_FeedbackMessage
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ptz_action_server_msgs__action__PtzFrame_FeedbackMessage
    std::shared_ptr<ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtzFrame_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtzFrame_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtzFrame_FeedbackMessage_

// alias to use template instance with default allocator
using PtzFrame_FeedbackMessage =
  ptz_action_server_msgs::action::PtzFrame_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace ptz_action_server_msgs

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace ptz_action_server_msgs
{

namespace action
{

struct PtzFrame
{
  /// The goal message defined in the action definition.
  using Goal = ptz_action_server_msgs::action::PtzFrame_Goal;
  /// The result message defined in the action definition.
  using Result = ptz_action_server_msgs::action::PtzFrame_Result;
  /// The feedback message defined in the action definition.
  using Feedback = ptz_action_server_msgs::action::PtzFrame_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = ptz_action_server_msgs::action::PtzFrame_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = ptz_action_server_msgs::action::PtzFrame_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = ptz_action_server_msgs::action::PtzFrame_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct PtzFrame PtzFrame;

}  // namespace action

}  // namespace ptz_action_server_msgs

#endif  // PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_FRAME__STRUCT_HPP_
