// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ptz_action_server_msgs:action/PtzMove.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_MOVE__STRUCT_H_
#define PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_MOVE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'ptz'
#include "ptz_action_server_msgs/msg/detail/ptz__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_Goal
{
  ptz_action_server_msgs__msg__Ptz ptz;
} ptz_action_server_msgs__action__PtzMove_Goal;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_Goal.
typedef struct ptz_action_server_msgs__action__PtzMove_Goal__Sequence
{
  ptz_action_server_msgs__action__PtzMove_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_Result
{
  bool success;
  rosidl_runtime_c__String message;
} ptz_action_server_msgs__action__PtzMove_Result;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_Result.
typedef struct ptz_action_server_msgs__action__PtzMove_Result__Sequence
{
  ptz_action_server_msgs__action__PtzMove_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'ptz_remaining'
// already included above
// #include "ptz_action_server_msgs/msg/detail/ptz__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_Feedback
{
  ptz_action_server_msgs__msg__Ptz ptz_remaining;
} ptz_action_server_msgs__action__PtzMove_Feedback;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_Feedback.
typedef struct ptz_action_server_msgs__action__PtzMove_Feedback__Sequence
{
  ptz_action_server_msgs__action__PtzMove_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "ptz_action_server_msgs/action/detail/ptz_move__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  ptz_action_server_msgs__action__PtzMove_Goal goal;
} ptz_action_server_msgs__action__PtzMove_SendGoal_Request;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_SendGoal_Request.
typedef struct ptz_action_server_msgs__action__PtzMove_SendGoal_Request__Sequence
{
  ptz_action_server_msgs__action__PtzMove_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} ptz_action_server_msgs__action__PtzMove_SendGoal_Response;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_SendGoal_Response.
typedef struct ptz_action_server_msgs__action__PtzMove_SendGoal_Response__Sequence
{
  ptz_action_server_msgs__action__PtzMove_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} ptz_action_server_msgs__action__PtzMove_GetResult_Request;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_GetResult_Request.
typedef struct ptz_action_server_msgs__action__PtzMove_GetResult_Request__Sequence
{
  ptz_action_server_msgs__action__PtzMove_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_move__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_GetResult_Response
{
  int8_t status;
  ptz_action_server_msgs__action__PtzMove_Result result;
} ptz_action_server_msgs__action__PtzMove_GetResult_Response;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_GetResult_Response.
typedef struct ptz_action_server_msgs__action__PtzMove_GetResult_Response__Sequence
{
  ptz_action_server_msgs__action__PtzMove_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "ptz_action_server_msgs/action/detail/ptz_move__struct.h"

/// Struct defined in action/PtzMove in the package ptz_action_server_msgs.
typedef struct ptz_action_server_msgs__action__PtzMove_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  ptz_action_server_msgs__action__PtzMove_Feedback feedback;
} ptz_action_server_msgs__action__PtzMove_FeedbackMessage;

// Struct for a sequence of ptz_action_server_msgs__action__PtzMove_FeedbackMessage.
typedef struct ptz_action_server_msgs__action__PtzMove_FeedbackMessage__Sequence
{
  ptz_action_server_msgs__action__PtzMove_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ptz_action_server_msgs__action__PtzMove_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PTZ_ACTION_SERVER_MSGS__ACTION__DETAIL__PTZ_MOVE__STRUCT_H_
