// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ptz_action_server_msgs:msg/PtzState.idl
// generated code does not contain a copyright notice

#ifndef PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__TRAITS_HPP_
#define PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ptz_action_server_msgs/msg/detail/ptz_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace ptz_action_server_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PtzState & msg,
  std::ostream & out)
{
  out << "{";
  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << ", ";
  }

  // member: pan
  {
    out << "pan: ";
    rosidl_generator_traits::value_to_yaml(msg.pan, out);
    out << ", ";
  }

  // member: tilt
  {
    out << "tilt: ";
    rosidl_generator_traits::value_to_yaml(msg.tilt, out);
    out << ", ";
  }

  // member: zoom
  {
    out << "zoom: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PtzState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: pan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pan: ";
    rosidl_generator_traits::value_to_yaml(msg.pan, out);
    out << "\n";
  }

  // member: tilt
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tilt: ";
    rosidl_generator_traits::value_to_yaml(msg.tilt, out);
    out << "\n";
  }

  // member: zoom
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zoom: ";
    rosidl_generator_traits::value_to_yaml(msg.zoom, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PtzState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ptz_action_server_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ptz_action_server_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ptz_action_server_msgs::msg::PtzState & msg,
  std::ostream & out, size_t indentation = 0)
{
  ptz_action_server_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ptz_action_server_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ptz_action_server_msgs::msg::PtzState & msg)
{
  return ptz_action_server_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ptz_action_server_msgs::msg::PtzState>()
{
  return "ptz_action_server_msgs::msg::PtzState";
}

template<>
inline const char * name<ptz_action_server_msgs::msg::PtzState>()
{
  return "ptz_action_server_msgs/msg/PtzState";
}

template<>
struct has_fixed_size<ptz_action_server_msgs::msg::PtzState>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ptz_action_server_msgs::msg::PtzState>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ptz_action_server_msgs::msg::PtzState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PTZ_ACTION_SERVER_MSGS__MSG__DETAIL__PTZ_STATE__TRAITS_HPP_
